 pro readstuf
   COMMON IMDATA,im,imlast,header,oheader,imsize,contrast,ocontrast,dim,filename,$
         outname, helpfile, selection,oselection,traceplot,saveflag

   COMMON IMAGETEXT_Comm, IMAGETEXT

    WIDGET_CONTROL, /HOURGLASS
          saveflag=1
          imlast=im
          dim=size(im)
          ;# RESET SELECTION
          p1=[0.0,0.0+(imsize(1)-dim(2))]
          p2=[dim(1)-1,(dim(2)-1)+(imsize(1)-dim(2))]
          selection=fill_select(0.0,0.0,p1,p2,p1)
          oselection=selection
          ;# CONVERT BYTE INTO SHORTWORD
          if dim(3) eq 1 then im=fix(im)
          pim=im(40:dim(1)-41,40:dim(2)-41)
          contrast=[long(min(pim)),long(max(pim))]
          ocontrast=contrast
          erase
          tv,bytscl(im,contrast(0),contrast(1)),0,imsize(1)-dim(2)
          loadct,0
end

 pro bbsoread,intitle,forceread
 ;# FITS & JPEG READER FOR BBSOFITS USING: readfits.pro, read_jpeg.pro
 ;# and read_gif.pro
 ;# by Anders Johannesson & Scot Kleinman 1996
 ;# This version modified Dec96 SJK to include GIFs and streamlining
 ;# Modified (sjk) Jan97 to allow forced reading of a FITS,JPG,GIF files
 ;# via the forceread variable: 0=normal open, 1=force FITS, 2=force JPEG and
 ;# 3=force GIF.
 ;# Modified by AJO may97 to read only green component of color gif
 
   COMMON IMDATA,im,imlast,header,oheader,imsize,contrast,ocontrast,dim,filename,$
         outname, helpfile, selection,oselection,traceplot,saveflag

   COMMON IMAGETEXT_Comm, IMAGETEXT

    WIDGET_CONTROL, /HOURGLASS
    old=filename

    ;# PICK FILE IN DIFFERENT OS
    a=!version & ver_no=fix(strmid(a.release,0,1))
    if ver_no gt 3 then begin
       if strpos(!version.os_family,'Windows') ne -1 then begin
          if (forceread ne 0) then begin
              filename=pickfile(GET_PATH=newpath, TITLE=intitle)
          endif else begin
              filename=pickfile(GET_PATH=newpath, $
                                FILTER = ['*.fts','*.fit','*.jpg','*.gif'], $
                                TITLE=intitle)
              endelse
       endif else begin
          if (forceread ne 0) then begin
              filename=pickfile(GET_PATH=newpath, TITLE=intitle)
          endif else begin
              ;filename=pickfile(GET_PATH=newpath, $
              ;                  FILTER = ['*.fts *.fit *.jpg *.gif'], $
              ;                  TITLE=intitle)
              filename=pickfile(GET_PATH=newpath, $
                                TITLE=intitle)
          endelse
       endelse
    endif else begin
       if (forceread ne 0) then begin
           filename=pickfile(GET_PATH=newpath, TITLE=intitle)
       endif else begin
          filename=pickfile(GET_PATH=newpath, $
                            FILTER = ['*.fts','*.fit','*.jpg','*.gif'], $
                            TITLE=intitle)
       endelse
    endelse
    str_start=strlen(newpath)
    str_length=strlen(filename)-str_start
    filename=strmid(filename,str_start,str_length)
    filename=strlowcase(filename)
    if strlen(filename) gt 1 then begin
       WIDGET_CONTROL, /HOURGLASS
       cd,newpath
       extension=strmid(filename,rstrpos(filename,'.')+1,3)
       if (forceread eq 1) or (extension eq 'fts') or (extension eq 'fit') then begin
          im=readfits(filename,header,/SILENT,/NOSCALE)
          dim=size(im)
          WIDGET_CONTROL, IMAGETEXT, set_value=[' '+$
                 strmid(filename,rstrpos(filename,'\')+1,99),$
                 ' '+string(format='(I4.0)',$
                 dim(1))+' x '+string(format='(I4.0)',dim(2))+' (FITS)']
       endif
       if (forceread eq 2) or (extension eq 'jpg') then begin
          read_jpeg,filename,im
          ;# IF COLOR JPEG USE ONLY GREEN CHANNEL ###
          dim=size(im)
          if dim(0) eq 3 then im=reform(im(1,*,*))
          header='NO HEADER - image was read as JPEG'
          WIDGET_CONTROL, IMAGETEXT, set_value=[' '+$
                 strmid(filename,rstrpos(filename,'\')+1,99),$
                 ' '+string(format='(I4.0)',$
                 dim(1))+' x '+string(format='(I4.0)',dim(2))+' (JPEG)']
       endif
       if (forceread eq 3) or (extension eq 'gif') then begin
          read_gif,filename,im,r,g,b
          dim=size(im)
          if abs(total(3.0*r-r-g-b)) gt 0 then begin
             im=g(im)
             header='NO HEADER - image was read as a true color GIF'
             WIDGET_CONTROL, IMAGETEXT, set_value=[' '+$
                    strmid(filename,rstrpos(filename,'\')+1,99),$
                    ' '+string(format='(I4.0)',$
                    dim(1))+' x '+string(format='(I4.0)',dim(2))+' (G component of GIF)']
          endif else begin 
             dim=size(im)
             if dim(0) eq 3 then im=reform(im(1,*,*))
             header='NO HEADER - image was read as GIF'
             WIDGET_CONTROL, IMAGETEXT, set_value=[' '+$
                    strmid(filename,rstrpos(filename,'\')+1,99),$
                    ' '+string(format='(I4.0)',$
                    dim(1))+' x '+string(format='(I4.0)',dim(2))+' (B/W GIF)']
          endelse
      endif
    endif else begin
       if strlen(old) gt 1 then begin
          filename=old
       endif else begin
          WIDGET_CONTROL, IMAGETEXT, set_value=' No image loaded'
       endelse
    endelse
end
	
	
